// MaxxCom.h -- header definitions for dll CyberMaxx Tracker
// Copyright (C) 1995  VictorMaxx Technologies, Inc.
// Author: Robert J. Gebis
// Date: 11 Oct 95 Ver 1.0
// Notes: ver 1.0 Pulled mode only

#ifndef __MAXXCOM_H__
  #define __MAXXCOM_H__

#ifdef MAXXCOM_LIB
#define DLLImEx __declspec(dllexport)
#else
#define DLLImEx __declspec(dllimport)
#endif


#define ABSOLUTE_MODE				"C"
#define RAW_DATA_MODE				"B"
#define ASCII_MODE					"E"
#define BINARY_MODE					"F"
#define SAMPLE_UPON_REQUEST			"G"
#define CONTINOUS_SAMPLE_MODE		"H"
#define TRANSITION_9600_19200		"K"
#define TRANSITION_19200_9600		"L"
#define CHECKSUM_ON					"M"
#define CHECKSUM_OFF				"N"
#define AVERAGE_FILTER_ON			"T"
#define AVERAGE_FILTER_OFF			"W"
#define HYSTERESIS_FILTER_ON		"P"
#define HYSTERESIS_FILTER_OFF		"O"
#define HARD_RESET					"R"
#define REQUEST_HANDSHAKE			"X"
#define REQUEST_VERSION_NUM			"V"
#define SEND_CURRENT_COORDINATE		"S"
#define SEND_CURRENT_SENSOR_DATA	"S"


#define Packet_5			0x80
#define Packet_10			0x81
#define Packet_15			0x82
#define Packet_20			0x83
#define Packet_25			0x84
#define Packet_30			0x85
#define Packet_35			0x86
#define Packet_40			0x87
#define Packet_45			0x88
#define Packet_50			0x89
#define Packet_55			0x8A
#define Packet_60			0x8B
#define Packet_65			0x8C
#define Packet_70			0x8D
#define Packet_75			0x8E
#define NL_Packet			0x8F

const char COM1[5] = "COM1";
const char COM2[5] = "COM2";
const char COM3[5] = "COM3";
const char COM4[5] = "COM4";
 


class DLLImEx CMaxxCom 
	{
		public:
				CMaxxCom();
				~CMaxxCom();
		BOOL	OpenCom(const char*);
		BOOL	CloseCom(const HANDLE);
		BOOL	AutoDetectComPort(void);
		BOOL	getDCB(void);
		BOOL	checkForCyberMaxx(void);
		BOOL	set9600(void);
		BOOL	set19200(void);
		BOOL	ReadFromPort(int*, int*, int*);		// Get Yaw,Pitch,Roll
		inline	int	getPortID(void) { return m_iPort_ID; }		

		void	errMsgBox(const char*);	
		void	CloseCom(void);					// close any active before exit
		 

		private:			  
			int				m_iPort_ID;
			int				m_iSamplingRate;		
			BOOL			m_bPortInUse;
		  	unsigned char	m_uszInBuffer[100];
		  	DCB				m_dcb;
			HANDLE			m_hCom;
			DWORD			dwNumOfBytesToWrite,
							dwNumToReadInBinMode,
							dwNumOfBytesRead;			
	};


#undef MAXXCOM_LIB

#endif
